import java.util.*;

/**
 * The class <code>AcousticEvent</code> transforms the information from server and writes it into a Vector
 *
 *@author Andreas Nibler
 */   
public class AcousticEvent extends Event
{

    /**a new <code>AcousticInfo</code> instance*/
    private AcousticInfo acousticInfo;

    /** Vector which contains all the information about the heared messages */
    private Vector acousticInfoList = new Vector();


    String message = "none";
    String sender = "none";
    double direction = 999.0;


    /** 
     * The  <code>Enumeration</code> of the Vector which contains all the information about the hear messages
     *
     *@return an <code>Enumeration</code> of the Vector 
     */
    public Enumeration elements() {return acousticInfoList.elements();}


    /** 
     * Adds a new <code>AcousticInfo</code> to the Vector 
     *
     *@param an <code>AcousticInfo</code> value 
     */
    public void add(AcousticInfo acousticInfo) {acousticInfoList.addElement(acousticInfo);}


    /**
     * tests if there is  an acoustic event incoming
     *
     *@return an <code>boolean</code> value
     */  
    public boolean isAcousticEvent() {return true;}


    /**
     * creates a new <code>AcoustisEvent</code> instance
     *
     *@param message
     */
    public AcousticEvent(String message)
    {	
	String message1 =  "("+message.substring(6);
	StringTokenizer ac0 = new StringTokenizer(message1, "()");
	String ac3 = ac0.nextToken();
	StringTokenizer ac1 = new StringTokenizer(ac3, " ");
	String sendertest="";

	int time = Integer.parseInt(ac1.nextToken());

		sendertest = ac1.nextToken();

		if (!sendertest.equals(" "))
		    {

			if (sendertest.equals("online_coach_left"))
			{
			    sender = "online_coach_left";
			}
			else
			{
			    if (sendertest.equals("online_coach_right"))
			    {
				sender = "online_coach_right";
			    }
			    else
			    {
				if (sendertest.equals("referee"))
				{
				    sender = "referee";
				}
				else
				{
				    if (sendertest.equals("self"))
				    {
					sender = "self";
				    }
				    else
				    {
					direction =  Double.valueOf(sendertest).doubleValue();
				    }
				}
			    }

			}

		    }

	if (ac1.hasMoreTokens()) message = ac1.nextToken();
       
	//System.out.println(time+" "+sender+" "+direction+" "+message);

	acousticInfo = new AcousticInfo(sender, time, direction, message);
	this.add(acousticInfo);
    }
}
