/**
 * The class <code>AcousticInfo</code> defines a new data type for saving the information 
 *about the acoustic messages
 *(currently not used)
 * 
 *@author Andreas Nibler
 */
public class AcousticInfo
{
    /** sender of the message */
    private String sender;
    /** current cycle */
    private int time;
    /** direction to the sender of the message */
    private double direction;
    /** received message */ 
    private String message;


    /**
     * creates an <code>AcousticInfo</code> instance
     *
     *@param sender a sender of the massage
     *
     *@param time the current cycle
     *
     *@param direction the direction to the sender of the message 
     *
     *@param message an <code>String</code> value which contains the received message 
     */
    AcousticInfo(String sender, int time, double direction, String message)
    {
	this.sender=sender;
	this.time=time;
	this.direction=direction;
	this.message=message;
    }


    /**
     * The sender of the message
     *
     *@return sender
     */
    public String sender() {return sender;}


    /**
     * The current cycle
     *
     *@return time
     */
    public int time() {return time;}


    /**
     * The direction to the sender of the message
     *
     *@direction
     */
    public double direction() {return direction;}


    /**
     * The received message
     *
     *@message
     */
    public String message() {return message;}
}

