import java.util.*;

/**
 * The class <code>BodyEvent</code> trasforms the information from server and writes it into a Vector
 *
 *@author Andreas Nibler
 */
public class BodyEvent extends Event
{

    /** a Vector for the sence-body messages */ 
    private Vector bodyInfoList = new Vector();
    
    /**a new <code>BodyInfo</code> instance*/
    private BodyInfo bodyInfo;

    /** an <code>Enumeration</code> of the Vector */
    public Enumeration elements() {return bodyInfoList.elements();}
    

    /** 
     * Adds an new <code>BodyInfo</code> instance to th Vector */
    public void add(BodyInfo bodyInfo) {bodyInfoList.addElement(bodyInfo);}


    /** 
     * tests, if there is an body event incoming 
     *
     *@param a <code>boolean</code> value
     */
    public boolean isBodyEvent() {return true;}

    double amountofSpeed = 999.0;
    double directionofSpeed = 999.0;
    double headAngle;
    

    /**
     * creates an new <code>BodyEvent</code> instance
     *
     *@param message a <code>String</code> value
     */ 
    public BodyEvent(String message)
    {

	//System.out.println(" IM BODYEVENT KONSTRUKTOR !");
	
	//System.out.println(" DIE aufzuspaltende message :" + message); 
	StringTokenizer bo = new StringTokenizer(message, "()");
	String a = bo.nextToken();
	String b = bo.nextToken();
	String c = bo.nextToken();
	String d = bo.nextToken();
	String h = bo.nextToken();     
	String g = bo.nextToken();
	String j = bo.nextToken();
	String k = bo.nextToken();
	String l = bo.nextToken();
	String m = bo.nextToken();
	String n = bo.nextToken();
	
	StringTokenizer bo2 = new StringTokenizer(d, " ");
	String speed = bo2.nextToken();

	try
	    {    
		//System.out.println("BODYEVENT TOKENIZER AAAAAAAA: "+ a);
		//System.out.println("BODYEVENT TOKENIZER BBBBBBBB: "+ b);
		//System.out.println("BODYEVENT TOKENIZER CCCCCCCC: "+ c);
		//System.out.println("BODYEVENT TOKENIZER DDDDDDDD: "+ d);
		//System.out.println("BODYEVENT TOKENIZER HHHHHHHH: "+ h);
		//System.out.println("BODYEVENT TOKENIZER GGGGGGGG: "+ g);
		//System.out.println("BODYEVENT TOKENIZER JJJJJJJJ: "+ j);
		//System.out.println("BODYEVENT TOKENIZER KKKKKKKK: "+ k);
		//System.out.println("BODYEVENT TOKENIZER LLLLLLLL: "+ l);
		//System.out.println("BODYEVENT TOKENIZER MMMMMMMM: "+ m);
		//System.out.println("BODYEVENT TOKENIZER NNNNNNNN: "+ n);
		
		amountofSpeed = Double.parseDouble(bo2.nextToken());
		directionofSpeed = Double.parseDouble(bo2.nextToken());
	    }

	catch(NumberFormatException e)
	    {
		amountofSpeed = 999.0;
		directionofSpeed = 999.0;   
	    }
	
	StringTokenizer bo3 = new StringTokenizer(k, " ");
	//System.out.println("BODYEVENT TOKENIZER22222222222: "+bo3);
	
	String head_angle = bo3.nextToken();

	try
	    {
		//System.out.println(" K ist " + bo3.nextToken());
		headAngle = Double.parseDouble(bo3.nextToken());
	    }
			
	catch(NumberFormatException f)
	    {
		headAngle = 999.0; 
	    }
	      				
	bodyInfo = new BodyInfo(amountofSpeed, directionofSpeed, headAngle);
	this.add(bodyInfo);
    }
}


