/**
 * The class <code>VisualInfo</code> defines a new data type for saving all the needed body information  
 *about a seen object. 
 *
 * @author Andreas Nibler
 */
public class BodyInfo
{
    /** amount of seed of the player */   
    private double amountofSpeed;
    /** direction of speed of the player */
    private double directionofSpeed;
    /** angle of the player's head */
    private double headAngle;


    /**
     * Creates a new <code>BodyInfo</code> instance
     *
     *@param amountofSpeed an amount of the player's speed
     *
     *@param directionofSpeed a direction of the player's speed
     *
     *@param headAngle an angle of the plaer's head
     */
    BodyInfo(double amountofSpeed, double directionofSpeed, double headAngle)
    {

	this.amountofSpeed=amountofSpeed;
	this.directionofSpeed = directionofSpeed;
	this.headAngle = headAngle;

    }


    /**
     * The amount of player's speed
     *
     *@return amountofSpeed
     */
    public double amountOfSpeed() {return amountofSpeed;}


    /** 
     * The direction of the player's speed
     *
     *@param directionofSpeed
     */ 
    public double directionOfSpeed() {return directionofSpeed;}


    /**
     * The angle of the player's head
     *
     *@return headAngle
     */
    public double getHeadAngle() {return headAngle;}


}
