/**
 * The class <code>Event</code> is the superclass of all events to be represented
 * during the game.
 *
 * @author Andreas Nibler
 */
public abstract class Event
{

    /**
     * indicates that the event type is not a body event
     *
     * @return a <code>boolean</code> value indicating that this event is not a
     * <code>BodyEvent</code>
     */
     public boolean isBodyEvent() {return false;}

    /**
     * indicates that the event type is not a visual event
     *
     * @return a <code>boolean</code> value indicating that this event is not a
     * <code>VisualEvent</code>
     */
    public boolean isVisualEvent() {return false;}
    
    /**
     * indicates that the event type is not a acoustic event
     *
     *@return a <code>boolean</code> value indicating that event is not a <code>AcousticEvent</code>
     */ 
    public boolean isAcousticEvent() {return false;}

}




