import java.lang.Math;
import java.util.*;
import java.awt.*;
import java.awt.geom.Point2D;

/* This class implements methods for players of all kind,
 * which are not trivial methods like kick or dash.
 *
 *@author Sanaz Jalayer
 *
 */

public class SuperPlayer
{

    private int counter = 0;
    /** the current side of the team */ 
    private char side;

    /** a new <code>Parser</code> instance */
    private Parser parser;

    /** a new <code>GlobalView</code> instance */
    private GlobalView globalView;

    /** a hash map for the startposition */
    private HashMap startPosition = new HashMap();

    //Points belonging to HashMap startPosition
   
    /**start Position of defense player 1*/
    Point2D.Double D1 = new Point2D.Double(-30.0,-20.4);
   /**start Position of defense player 2*/
    Point2D.Double D2= new Point2D.Double(-30.0,-1.0);
    /**start Position of defense player 3*/
    Point2D.Double D3= new Point2D.Double(-30.0,1.0);
    /**start Position of defense player 4*/
    Point2D.Double D4= new Point2D.Double(-30.0,20.4);
    /**start Position of Midfield player 5*/
    Point2D.Double M5= new Point2D.Double(-17.5,-17.0);
    /**start Position of Midfield player 6*/
    Point2D.Double M6= new Point2D.Double(-0.5,0.0);
    /**start Position of Midfield player 7*/
    Point2D.Double M7= new Point2D.Double(-17.5,17.0);
    /**start Position of attack player 8*/
    Point2D.Double A8= new Point2D.Double(-1.5,-17.0);
    /**start Position of attack player 9*/
    Point2D.Double A9= new Point2D.Double(-1.5,4.0);
    /**start Position of attack player 10*/
    Point2D.Double A10= new Point2D.Double(-1.5,17.0);
    /**start Position of goalie player 11*/
    Point2D.Double G11 = new Point2D.Double(-48.0,0.0);
    //HashMap Initialisation takes palce in Constructor...

    private HashMap defenseArea = new HashMap();

    //Points belonging to HashMap defenseArea
    
    /**area border of defense player 1*/
    Point2D.Double da1 = new Point2D.Double(-53.5,-5.0);    //
    /**area border of defense player 2*/
    Point2D.Double da2 = new Point2D.Double(-53.5, 10.0);
    /**area border of defense player 3*/
    Point2D.Double da3 = new Point2D.Double(-53.5, 20.0);
    /**area border of defense player 4*/
    Point2D.Double da4 = new Point2D.Double(-53.5, 35.0);
    /**area border of Midfield player 5*/
    Point2D.Double mi5 = new Point2D.Double(-20.0, -10.0);
    /**area border of Midfield player 6*/
    Point2D.Double mi6 = new Point2D.Double(-20.0, 12.5);
    /**area border of Midfield player 7*/
    Point2D.Double mi7 = new Point2D.Double(-20.0, 35.0);
    /**area border of attack player 8*/
    Point2D.Double at8 = new Point2D.Double( 10.0, -10.0);  //+30  -15
    /**area border of attack player 9*/
    Point2D.Double at9 = new Point2D.Double( 10.0, 12.5);// +30 -15
    /**area border of attack player 10*/
    Point2D.Double at10 = new Point2D.Double( 10.0, 35.0); // +30 -15
    /**area border of goalie player 11*/
    Point2D.Double go11 = new Point2D.Double(-53.5,10.0);

    /**wait position of goalie player 11*/
    Point2D.Double go12 = new Point2D.Double(-53.5, 5.0);
    // WARTEPOSITION DES GOALIE  
    //HashMap Initialisation takes palce in Constructor...


    /** 
     *Creates a new <code>SuperPlayer</code> instance
     *
     *@param parser a <code>Parser</code> instance 
     *
     *@param side a <code>char</code> value which contains the current side of the team
     *
     *@param globalView a <code>GlobalView</code> instance
     */
    SuperPlayer(Parser parser, char side, GlobalView globalView)
    {
	//System.out.println("KONSTRUKTOR SUPERPLAYER!!!! ANFANG!!!!!!!!!!!!");

	this.side = side;
	this.parser = parser;
	this.globalView = globalView;

	//Initialisation HashMap startPosition
	startPosition.put("0", D1);
	startPosition.put("1", D2);
	startPosition.put("2", D3);
	startPosition.put("3", D4);
	startPosition.put("4", M5);
	startPosition.put("5", M6);
	startPosition.put("6", M7);
	startPosition.put("7", A8);
	startPosition.put("8", A9);
	startPosition.put("9", A10);
	startPosition.put("10", G11);

	//Initialisation HashMap defenseArea
	defenseArea.put("0", da1);
	defenseArea.put("1", da2);
	defenseArea.put("2", da3);
	defenseArea.put("3", da4);
	defenseArea.put("4", mi5);
	defenseArea.put("5", mi6);
	defenseArea.put("6", mi7);
	defenseArea.put("7", at8);
	defenseArea.put("8", at9);
	defenseArea.put("9", at10);
	defenseArea.put("10",go11);
	defenseArea.put("11",go12);




    }

    /** 
     *Checks if the ball is in the own half of the field
     *
     *@param ballInfo a <code>VisualInfo</code> value which contains all the information about the ball
     */ 
    public boolean ballInOwnHalf(VisualInfo ballInfo)
    {
	if(ballInfo.getX() < 0) { return true;}
	else return false;

    }

    /**
     *Sets all the players to their start position
     *
     *@param playerNumber a <code>int</code> value which contains the number of the player
     */
   public void setPositionStart(int playerNumber)
    {

	Point2D.Double coordinates = new Point2D.Double();
	coordinates = (Point2D.Double)startPosition.get(Integer.toString(playerNumber));

	parser.move(coordinates.getX(),coordinates.getY());


    }


    /**
     *Returns the area border of the player
     *
     *@param playerNumber a <code>int</code> value which contains the number of the player
     *
     *@return <code>Point2D.Double</code> contains the area border of the player 
     */
    public Point2D.Double getDefAr(int playerNumber)
    {
	return  (Point2D.Double)defenseArea.get(Integer.toString(playerNumber));
    }

 public Point2D.Double getStartPos(int playerNumber)
    {
	return  (Point2D.Double)startPosition.get(Integer.toString(playerNumber));
    }
    /**
     *Decides if the ball is in the area of the player
     *
     *@param ballInfo a <code>VisualInfo</code> value which contains current ball information
     *
     *@param playerNumber a <code>int</code> value which contains the number of the player
     *
     *@return <code>boolean</code> contains true if the ball is in the area of the player
     */
    public boolean ballInDefA(VisualInfo ballInfo, int playerNumber)
    { 



	  Point2D.Double defAr =  (Point2D.Double)defenseArea.get(Integer.toString(playerNumber));

	  if(playerNumber == 11)  //GOALIE IN WARTEPOSITION
	      {
		  if ((ballInfo.getX() >= defAr.getX())  && (ballInfo.getX() <= (defAr.getX()+3.0)))
		      {
			  if((ballInfo.getY() <= defAr.getY()) && (ballInfo.getY() >= (defAr.getY()-10.0)))
			      {
				  return true;
			      }
			  return false;
		      }
		  
		  else return false;
	      }
	  

	  if(playerNumber == 10)  //GOALIE
	      {
		  if ((ballInfo.getX() >= defAr.getX())  && (ballInfo.getX() <= (defAr.getX()+15.0)))
		      {
			  if((ballInfo.getY() <= defAr.getY()) && (ballInfo.getY() >= (defAr.getY()-22.0)))
			      {
				  return true;
			      }
			  return false;
		      }
		  
	  else return false;
	      }

	  if(playerNumber >=0  && playerNumber <=3)  //DEFENSE
	      {
		  if ((ballInfo.getX() >= defAr.getX())  && (ballInfo.getX() <= (defAr.getX()+40.0)))
		      {
			  if((ballInfo.getY() <= defAr.getY()) && (ballInfo.getY() >= (defAr.getY()-30.0)))
			      {
				  return true;
			      }
			  return false;
		      }
		  
	  else return false;
	      }


	  if(playerNumber >=4  && playerNumber <=6)  // MIDFIELD
	      {
		  if ((ballInfo.getX() >= defAr.getX())  && (ballInfo.getX() <= (defAr.getX()+41.0)))
		      {
			  if((ballInfo.getY() <= defAr.getY()) && (ballInfo.getY() >= (defAr.getY()-25.0)))
			      {
				  return true;
			      }
			  return false;
		      }
		  
		  else return false;
	      }
	  if(playerNumber >=7  && playerNumber <=9)  //ATTACK
	      {
		  if ((ballInfo.getX() >= defAr.getX())  && (ballInfo.getX() <= (defAr.getX()+43.5)))
		      {
			  if((ballInfo.getY() <= defAr.getY()) && (ballInfo.getY() >= (defAr.getY()-30.0)))
			      {
				  return true;
			      }
			  return false;
		      }
		  
		  else return false;
	      }
	
	  else return false;  
    }

    /**
     *Decides if the player is in his area
     *
     *@param selfPosition a <code>Point2D.Double</code> contains the current
     *absolute coordinates of the player
     *
     *@param playerNumber a <code>int</code> value which contains the number of the player
     *
     *@return <code>boolean</code> contains true if the player is in his area
     */
  public boolean checkIfInDefArea(Point2D.Double selfPosition, int playerNumber)
    { 



	  Point2D.Double defAr =  (Point2D.Double)defenseArea.get(Integer.toString(playerNumber));

	  if(playerNumber == 11)  //GOALIE IN WARTEPOSITION
	      {
		  if ((selfPosition.getX() >= defAr.getX())  && (selfPosition.getX() <= (defAr.getX()+5.0)))
		      {
			  if((selfPosition.getY() <= defAr.getY()) && (selfPosition.getY() >= (defAr.getY()-10.0)))
			      {
				  return true;
			      }
			  return false;
		      }
		  
		  else return false;
	      }


	 if(playerNumber == 10)  //GOALIE
	      {
		  if ((selfPosition.getX() >= defAr.getX())  && (selfPosition.getX() <= (defAr.getX()+15.0)))
		      {
			  if((selfPosition.getY() <= defAr.getY()) && (selfPosition.getY() >= (defAr.getY()-22.0)))
			      {
				  return true;
			      }
			  return false;
		      }
		  
	  else return false;
	      }
	
	     


	      

	  if(playerNumber >=0  && playerNumber <=3)  //DEFENSE
	      {
		  if ((selfPosition.getX() >= defAr.getX())  && (selfPosition.getX() <= (defAr.getX()+40.0)))
		      {
			  if((selfPosition.getY() <= defAr.getY()) && (selfPosition.getY() >= (defAr.getY()-30.0)))
			      {
				  return true;
			      }
			  return false;
		      }
		  
	  else return false;
	      }


	  if((playerNumber >=4)  && (playerNumber <=6))  // MIDFIELD
	      {
		  if ((selfPosition.getX() >= defAr.getX())  && (selfPosition.getX() <= (defAr.getX()+41.0)))
		      {
			  if((selfPosition.getY() <= defAr.getY()) && (selfPosition.getY() >= (defAr.getY()-25.0)))
			      {
				  return true;
			      }
			  return false;
		      }
		  
		  else return false;
	      }
	  if(playerNumber >=7  && playerNumber <=9)  //ATTACK
	      {
		  if ((selfPosition.getX() >= defAr.getX())  && (selfPosition.getX() <= (defAr.getX()+43.5)))
		      {
			  if((selfPosition.getY() <= defAr.getY()) && (selfPosition.getY() >= (defAr.getY()-30.0)))
			      {
				  return true;
			      }
			  return false;
		      }
		  
		  else return false;
	      }
	
	  else return false;  
    }


 public boolean checkIfInDefPoint(Point2D.Double selfPosition, int playerNumber)
    { 
	Point2D.Double defAr =  (Point2D.Double)defenseArea.get(Integer.toString(playerNumber));
	
	//  if(((defAr.getX() >= selfPosition.getX()-3.0) || (defAr.getX()  selfPosition.getX()+3.0) ) && ( (defAr.getY() == selfPosition.getY()-3.0) ||(defAr.getY() == selfPosition.getY()+3.0)))
	if(getDistance(selfPosition, defAr.getX(), defAr.getY()) <= 20.0)
	    {
		return true;
	    }
	return false;

    }


    /**
     *Searches the ball
     *
     *@param directionLastBallInfo a <code>double</code> value which contains the last
     *known direction of the ball
     *
     *@param dirChange a <code>double</code> value which contains the direction change of the ball
     *
     *@param headAngle <code>double</code> value which contains the head angle of the player
     */
    public void searchBall(double directionLastBallInfo, double dirChange, double headAngle, double distChange)
    {
	double ballDir = directionLastBallInfo + dirChange;

	if(ballDir < 0.0)
	    {
		if(  Math.abs(  headAngle) < 80.0)
		    {
			parser.turnNeck(-10);
		    }
		else
		    {
			parser.turnNeck(-headAngle);
			parser.turn(headAngle);
		    }
	    }

	else
	    {
		if(  Math.abs(  headAngle) < 80.0)
		    {
			parser.turnNeck(10.0);
		    }
		else
		    {
			parser.turnNeck(-headAngle);
			parser.turn(headAngle);
		    }
		
	    }





	//  if(directionLastBallInfo < 0.0)  // ball links
//  	    {
//  		if(ballDir < 0.0)         //ball wird links sein
//  		    {
//  			if(distChange < 2.0)      //ball langsam
//  			    {
//  				if(  Math.abs(  headAngle) < 80.0)
//  				    {
//  					parser.turnNeck(-10);
//  				    }
//  				else               //ball schnell
//  				    {
//  					parser.turnNeck(-headAngle);
//  					parser.turn(headAngle);
//  				    }
//  			    }
			
//  			else              //ball wird rechts sein
//  			    {
				

//  			    }
			
			
//  	    }
	    
	
//  	else  //lastBallInfo >= 0.0
//  	    {

//  		if(distChange < 4.0)
		    
//  		    if(  Math.abs(  headAngle) < 80.0)
//  			{
//  			    parser.turnNeck(10.0);
//  			}
//  		    else
//  			{
//  			    parser.turnNeck(-headAngle);
//  			    parser.turn(headAngle);
//  			}
		
//  		else 
//  		    {
//  			parser.turnNeck(-(2 * headAngle));
//  			parser.turn(90.0);
//  		    }
//  	    }
    }

    /**
     *Calculates a special direction for turning or kicking 
     *
     *@param playerInfo1 a <code>VisualInfo</code> contains infos about the closest player of the
     *opponent team
     *
     *@param turnDir a <code>double</code> value which contains normal turn or kick direction
     *
     *@param selfPosition a <code>Point2D.Double</code> contains the current
     *absolute coordinates of the player
     *
     *@return <code>double</code> the (maybe) modified turn or kick direction
     */
    public double findSpecialKickDirection(VisualInfo playerInfo1, double turnDir, Point2D.Double selfPosition)
    {
	double specialKickDirection = turnDir;

	if(playerInfo1.name().equals(""))
	    {
		return specialKickDirection;
	    }
	else
	    {
		if((Math.abs(turnDir)+20.0) < (Math.abs(playerInfo1.direction())))
		    {
			if(selfPosition.getY() < playerInfo1.getY())
			    {
				specialKickDirection = turnDir - 50.0;
			    }
			else
			    {
				specialKickDirection = turnDir + 50.0;
			    }
		    }
		
		return specialKickDirection;
	    }		       
    }
    

    public void goToInitialPosition(double direction, double x, double y, Point2D.Double selfPosition)
    {
	
	
	
	if((counter == 0) )
	    {
		
		parser.turn(direction);
		counter++;	
	    }
	
	else
	    {
		if((50*getDistance(selfPosition, x,y)) < 100.0)
		    {
			parser.dash(50*getDistance(selfPosition, x,y));
		    }
		else
		    {
			parser.dash(100);
		    }

		counter = 0;
	    }
    }
    


    /**
     *Decides if player is in good position to kick on goal 
     *
     *@param selfPosition a <code>Point2D.Double</code> contains the current
     *absolute coordinates of the player
     *
     *@return <code>boolean</code> value is true if player is in good position to kick on goal 
     */
    public boolean checkGoodGoalPosition(Point2D.Double selfPosition)
    {

	
	if (selfPosition.getX() != 999.0)
	    {

		if(((Math.sqrt(Math.pow(selfPosition.getX()-52.5,2)+Math.pow(selfPosition.getY()-0,2)))<=40 ) && ((Math.sqrt(Math.pow(selfPosition.getX()-52.5,2)+Math.pow(selfPosition.getY()-0,2))) >=5))
		    {
			return true;
		    }
		else
		    {
			return false;
		    }
	    }
	else
	    {
		return false;
	    }
    }

    /**
     *Calculates the distance between player and a fix point
     *
     *@param selfPosition a <code>Point2D.Double</code> contains the current
     *absolute coordinates of the player
     *
     *@param x a <code>double</code> value which contains the x-coordinate of the fix point
     *
     *@param y a <code>double</code> value which contains the y-coordinate of the fix point
     *
     *@return <code>double</code> value which contains the distance between player and the fix point
     */
    public double getDistance(Point2D.Double selfPosition, double x, double y)
	{

	    double distance = 0;
	    distance = Math.sqrt(Math.pow((selfPosition.getX()-x),2) + Math.pow((selfPosition.getY()-y),2));
	    return distance;
	}

}










































