import java.util.*;

/**The classe transforms the visual server messages and writes it into a <code>Vector</code> 
 * 
 * @author Andreas Nibler
 */
public class VisualEvent extends Event
{

    /**a new <code>VisualInfo</code> instance*/
    private VisualInfo visualInfo;


    /**
     * List of <code>VisualInfo</code> values 
     * (for instance information about flags, other players, ball etc.
     *
     * @see VisualInfo
     */
    public Vector visualInfoList = new Vector();


    /**
     * The <code>Enumeration</code> of the Vector 
     *
     * @return an <code>Enumeration</code>  
     */
    public Enumeration elements() {return visualInfoList.elements();}

   
    /**
     *The <code>Vector</code> which contains all the needed information about the visual messages from server
     *
     *@return <code>Vector</code>
     */    
    public Vector getVector() {return visualInfoList;}
    

    /**
     * Adds a new <code>VisualInfo</code> instance into the Vector 
     *
     *@param <code>VisualInfo</code>
     */
    public void add(VisualInfo visualInfo) {visualInfoList.addElement(visualInfo);}


    /** defaulft values are 999, in order to test if they changed */
    double direction=999.0;
    double distance=999.0;
    double distChange=0.0;
    double dirChange=0.0;


    /**
     * tests if there is an visual event incoming
     */
    public boolean isVisualEvent() {return true;}


    /**
     * creates a new <code>VisualEvent</code> instance  
     */
    public VisualEvent(String message)
    {
        //Tokenizer benutzt runde Klammern als String Begrenzung

        StringTokenizer	tokenizer = new StringTokenizer(message, "()");

        // Liest die Zeit aus der Servernachricht
        // z.B. nehme den naechsten Token ab dem 4. Zeichen (substring(4)) und 
        // loesche die Leerzeichen (trim())
        // schreibe den erhaltenen Integerwert in time

        int time = Integer.parseInt(tokenizer.nextToken().substring(4).trim());

        // um alle Nachrichten zu verarbeiten, schaue ob mehr Tokens vorhanden
	// sind
	String code = new String();
        while (tokenizer.hasMoreTokens())
        {
          // empfange den Objektnamen, z.B "g r"
	    
	  try
	      {
		  code=tokenizer.nextToken(); 
	      }
	  catch(NoSuchElementException zxc)
	      {
		  System.out.println("Noch ne EXCEPTION!!!!!");
	      }

	  if (code.startsWith("B")) {code = code.toLowerCase();}

          // wenn der Token nicht leer ist...

          if (!code.equals(" "))
          {
            // schreibe den ganzen Token in data
	      String data = new String();
	      try
		  {
		      data = tokenizer.nextToken();
		  }
	      catch(NoSuchElementException cxz)
		  {
		      System.out.println("MESSAGE " + message );
		      System.out.println("CODE " + code );
		  }

	    // for(int i = 0; i < 100; i++)
		// System.out.println(" DATA : " + data);

            // und springe zum naechsten Token

            switch (code.charAt(0)) {

              // Der Fall "Ein Ball wurde gesehen":

              case 'b':

		  // ein neuer Tokenizer mit Leerzeichen als String Begrenzung
		  // wird benutzt

		  StringTokenizer st1   = new StringTokenizer(data, " ");

		  // wenn nur ein String uebergeben wird, (dies ist der Fall,
		  // wenn der Spieler weit vom Ball entfernt ist),
		  // so wird der Wert als Richtung, in der der Ball sich
		  // befindet, benutzt


		 


		  if (st1.countTokens() == 1)
		    {
			// wandelt den String in einen double um und speichert
			// unter direction ab
			String a = st1.nextToken();
			try{direction  = Double.valueOf(a).doubleValue();}
			catch(NumberFormatException st11)
			    {
				//System.out.println(" NUR st1.nextToken  aaaa " + a);
			    }
			catch(NoSuchElementException st11)
			    {
				//System.out.println(" NUR st1.nextToken  aaaa " + a);
			    }
			
		    }
		  else
		      {
			  // wenn zwei Strings uebergeben werden (Ball schon 
			  // etwas naeher am Spieler), so ist der erst Wert
			  // die Entfernung und der zweite die Richtung

			  if (st1.countTokens() == 2)
			      {

				  String a = st1.nextToken();
				  String b = st1.nextToken();
				  
				  try{
				      distance = Double.parseDouble(a);
				      direction = Double.parseDouble(b);
				  }
				  
				  catch(NumberFormatException st12)
				      {
				      //System.out.println(" MESSAGE " + message);
				      //System.out.println(" CODE " + code);
				      //System.out.println(" DATA"+ data);
				      //System.out.println(" NUR st1.nextToken  aaaa " + a);
				      //System.out.println(" NUR st1.nextToken bbbb " + b);
				      }
				  catch(NoSuchElementException nst12)
				      {
					  //System.out.println(" NUR st1.nextToken  aaaa " + a);
					  //System.out.println(" NUR st1.nextToken bbbb " + b);
				      }
				  //distance  = Double.valueOf(st1.nextToken()).doubleValue();
				  //direction = Double.valueOf(st1.nextToken()).doubleValue();
			      }
			  else
			      {
				  // Der dritte Wert ist nun die Entfernungs-
				  // aenderung
				  
				  if (st1.countTokens() == 3)
				      { 
					  String a = st1.nextToken();
					  String b = st1.nextToken(); 
					  String c = st1.nextToken();
					  
					  try{
					      distance  = Double.valueOf(a).doubleValue();
					       direction = Double.valueOf(b).doubleValue();
					       distChange = Double.valueOf(c).doubleValue();
					  }
					  catch(NumberFormatException st13)
					      {
						  //System.out.println(" MESSAGE " + message);
						  //System.out.println(" CODE " + code);
						  //System.out.println(" DATA " + data);
						  //System.out.println(" NUR st1.nextToken  aaaa " + a);
						  //System.out.println(" NUR st1.nextToken  bbbb " + b);
						  //System.out.println(" NUR st1.nextToken  cccc " + c);
					      }
					  catch(NoSuchElementException nst13)
					      {
						  //System.out.println(" MESSAGE " + message);
						  //System.out.println(" CODE " + code);
						  //System.out.println(" DATA " + data);
						  //System.out.println(" NUR st1.nextToken  aaaa " + a);
						  //System.out.println(" NUR st1.nextToken  bbbb " + b);
						  //System.out.println(" NUR st1.nextToken  cccc " + c);
					      }
				      }
				  else
				      {
					  // Der 4. Wert die Richtungs-
					  // aenderung
					
					  
					  
					  if (st1.countTokens() >= 4)
					      {
						  String a = st1.nextToken(); 
						  String b = st1.nextToken(); 
						  String c = st1.nextToken(); 
						  String d = st1.nextToken();
						  
						  try{
						      distance  = Double.valueOf(a).doubleValue();
						      direction = Double.valueOf(b).doubleValue();
						      distChange = Double.valueOf(c).doubleValue();
						      dirChange = Double.valueOf(d).doubleValue();
						  }
						  catch(NumberFormatException st14)
						      {  
							  //System.out.println(" MESSAGE " + message);
							  //System.out.println(" CODE " + code);
							  //System.out.println(" DATA " + data);
							  //System.out.println(" NUR st1.nextToken  aaaa " + a);
							  //System.out.println(" NUR st1.nextToken  bbbb " + b);
							  //System.out.println(" NUR st1.nextToken  cccc " + c);
							  //System.out.println(" NUR st1.nextToken  dddd " + d);
						      }
						  catch(NoSuchElementException nst14)
						      {   
							 //System.out.println(" MESSAGE " + message);
							  //System.out.println(" CODE " + code);
							  //System.out.println(" DATA " + data);
							  //System.out.println(" NUR st1.nextToken  aaaa " + a);
							  //System.out.println(" NUR st1.nextToken  bbbb " + b);
							  //System.out.println(" NUR st1.nextToken  cccc " + c);
							  //System.out.println(" NUR st1.nextToken  dddd " + d);
						      }
					      }
				      }
			      }
		      }
   
	    case 'g':
		
		// Der Fall "Tor gesehen", Rest analog zu "Ball gesehen"

		StringTokenizer st2   = new StringTokenizer(data, " ");
		
		
		if (st2.countTokens() == 1)
		    { 
			String a = st2.nextToken();
			
			try
			    {
				direction  = Double.valueOf(a).doubleValue();
			    }
			catch(NumberFormatException st21)
			    {
				//System.out.println(" MESSAGE " + message);
				//System.out.println(" CODE " + code);
				//System.out.println(" DATA " + data);
				//System.out.println(" NUR st2.nextToken  aaaa " + a);
			    }
			
			catch(NoSuchElementException nst21){
			    //System.out.println(" MESSAGE " + message);
			    //System.out.println(" CODE " + code);
			    //System.out.println(" DATA " + data);
			    //System.out.println(" NUR st2.nextToken  aaaa " + a);
			}		    }
		else
		    {
			if (st2.countTokens() == 2)
			    {
				String a = st2.nextToken();
				String b = st2.nextToken();
				
				try{
				    distance  = Double.valueOf(a).doubleValue();
				    direction = Double.valueOf(b).doubleValue();
				}
				
				catch(NumberFormatException st22){
 //System.out.println(" MESSAGE " + message);
				      //System.out.println(" CODE " + code);
				      //System.out.println(" DATA " + data);
				    //System.out.println(" NUR st2.nextToken  aaaa " + a);
				    //System.out.println(" NUR st2.nextToken  bbbb " + b);
				}
				catch(NoSuchElementException nst22){
				    //System.out.println(" MESSAGE " + message);
				    //System.out.println(" CODE " + code);
				    //System.out.println(" DATA " + data);
				    //System.out.println(" NUR st2.nextToken  aaaa " + a);
				    //System.out.println(" NUR st2.nextToken  bbbb " + b);
				}
			    }
			else
			    {
				if (st2.countTokens() == 3)
				    {
					String a = st2.nextToken();
					String b = st2.nextToken();
					String c = st2.nextToken();
					
					try{
					    distance  = Double.valueOf(a).doubleValue();
					    direction = Double.valueOf(b).doubleValue();
					    distChange = Double.valueOf(c).doubleValue();
					}
					catch(NumberFormatException st23){
					    //System.out.println(" MESSAGE " + message);
					    //System.out.println(" CODE " + code);
					    //System.out.println(" DATA " + data);
					    //System.out.println(" NUR st2.nextToken  aaaa " + a);
					    //System.out.println(" NUR st2.nextToken  bbbb " + b);
					    
					    //System.out.println(" NUR st2.nextToken  cccc " + c);
					}
					
					catch(NoSuchElementException nst23){
					    //System.out.println(" MESSAGE " + message);
					    //System.out.println(" CODE " + code);
					    //System.out.println(" DATA " + data);
					    //System.out.println(" NUR st2.nextToken  aaaa " + a);
					    //System.out.println(" NUR st2.nextToken  bbbb " + b);
					    
					    //System.out.println(" NUR st2.nextToken  cccc " + c);
					}
				    }
				else
				    {
					if (st2.countTokens() >= 4)
					    
					    {
						String a = st2.nextToken();
						String b = st2.nextToken();
						
						String c = st2.nextToken();
						String d = st2.nextToken();
						

						try{
						    distance  = Double.valueOf(a).doubleValue();
						    direction = Double.valueOf(b).doubleValue();
						    distChange = Double.valueOf(c).doubleValue();
						    dirChange = Double.valueOf(d).doubleValue();
						}
						catch(NumberFormatException st24){
						    //System.out.println(" MESSAGE " + message);
						    //System.out.println(" CODE " + code);
						    //System.out.println(" DATA " + data);
						    //System.out.println(" NUR st2.nextToken  aaaa " + a);
						    //System.out.println(" NUR st2.nextToken  bbbb " + b);
						    //System.out.println(" NUR st2.nextToken  cccc " + c);
						    //System.out.println(" NUR st2.nextToken  dddd " + d);
						}
						catch(NoSuchElementException st24){
						    //System.out.println(" MESSAGE " + message);
						    //System.out.println(" CODE " + code);
						    //System.out.println(" DATA " + data);
						    //System.out.println(" NUR st2.nextToken  aaaa " + a);
						    //System.out.println(" NUR st2.nextToken  bbbb " + b);
						    //System.out.println(" NUR st2.nextToken  cccc " + c);
						    //System.out.println(" NUR st2.nextToken  dddd " + d);
						}
					    }
				    }
			    }
		    }
		
		

	      case 'p':

		  // Der Fall Player (hier ist zu beachten, dass in code 
		  // nun Name des Spielers und dessen Position etc. stehen

		  StringTokenizer st3   = new StringTokenizer(data, " ");
	 
	 
		  if (st3.countTokens() == 1)
		      {
			  String a = st3.nextToken();
			  
			  try{
			      direction  = Double.valueOf(a).doubleValue();}
		      
		  
			  catch(NumberFormatException st31)
			      {
				  //System.out.println(" MESSAGE " + message);
				  //System.out.println(" CODE " + code);
				  //System.out.println(" DATA " + data);
				  //System.out.println(" DATA = " +data);
				  //System.out.println(" NUR st3.nextToken  aaaa " + a);
			      }
			  
			  catch(NoSuchElementException nst31)
			      {
				  //System.out.println(" MESSAGE " + message);
				  //System.out.println(" CODE " + code);
				  //System.out.println(" DATA " + data);
				  //System.out.println(" DATA = " +data);
				  //System.out.println(" NUR st3.nextToken  aaaa " + a);
			      }
		      }
		  else
		      {
			  if (st3.countTokens() == 2)
			      {
				  String a = st3.nextToken();
				  String b = st3.nextToken();
				 
				  try
				      {
					  distance  = Double.valueOf(a).doubleValue();
					  direction = Double.valueOf(b).doubleValue();
				      }
				  
				  catch(NumberFormatException st32)
				      {
					  //System.out.println(" MESSAGE " + message);
					  //System.out.println(" CODE " + code);
					  //System.out.println(" DATA " + data);
					  //System.out.println(" DATA = " +data);
					  //System.out.println(" NUR st3.nextToken  aaaa " + a);
					  //System.out.println(" NUR st3.nextToken  bbbb " + b);
				      }
				  catch(NoSuchElementException st32)
				      {
					  //System.out.println(" MESSAGE " + message);
					  //System.out.println(" CODE " + code);
					  //System.out.println(" DATA " + data);
					  //System.out.println(" DATA = " +data);
					  //System.out.println(" NUR st3.nextToken  aaaa " + a);
					  //System.out.println(" NUR st3.nextToken  bbbb " + b);
				      }
			      }
			  else
			      {
				  if (st3.countTokens() == 3)
				      {
					  String a = st3.nextToken();
					  String b = st3.nextToken();
					  String c = st3.nextToken();
					 
					  try{
					      distance  = Double.valueOf(a).doubleValue();
					      direction = Double.valueOf(b).doubleValue();
					      distChange = Double.valueOf(c).doubleValue();
					  }

					  catch(NumberFormatException st33)
					      {
						  //System.out.println(" MESSAGE " + message);
						  //System.out.println(" CODE " + code);
						  //System.out.println(" DATA " + data);
						  //System.out.println(" DATA = " +data);
						  //System.out.println(" NUR st3.nextToken  aaaa " + a);
						  //System.out.println(" NUR st3.nextToken  bbbb " + b);
						  //System.out.println(" NUR st3.nextToken  cccc " + c);
					      }
					  catch(NoSuchElementException st33)
					      {  
						  //System.out.println(" MESSAGE " + message);
						  //System.out.println(" CODE " + code);
						  //System.out.println(" DATA " + data);
						  //System.out.println(" DATA = " +data);
						  //System.out.println(" NUR st3.nextToken  aaaa " + a);
						  //System.out.println(" NUR st3.nextToken  bbbb " + b);
						  //System.out.println(" NUR st3.nextToken  cccc " + c);
					      }
				      }
				  else
				      {
					  if (st3.countTokens() >= 4)
					      {
						  
						  String a = st3.nextToken();
						  String b = st3.nextToken();
						  String c = st3.nextToken();
						  String d = st3.nextToken();
						  
						  try{
						      distance  = Double.valueOf(a).doubleValue();
						      direction = Double.valueOf(b).doubleValue();
						      distChange = Double.valueOf(c).doubleValue();
						      dirChange = Double.valueOf(d).doubleValue();
						  }
						  catch(NumberFormatException st34)
						      {
							  //System.out.println(" MESSAGE " + message);
							  //System.out.println(" CODE " + code);
							  //System.out.println(" DATA " + data);
							  //System.out.println(" DATA = " +data);
							  //System.out.println(" NUR st3.nextToken  aaaa " + a);
							  //System.out.println(" NUR st3.nextToken  bbbb " + b);
							  //System.out.println(" NUR st3.nextToken  cccc " + c);
							  //System.out.println(" NUR st3.nextToken  dddd " + d);
						      }
						  catch(NoSuchElementException st34)
						      {
  //System.out.println(" MESSAGE " + message);
				      //System.out.println(" CODE " + code);
				      //System.out.println(" DATA " + data);
							  //System.out.println(" DATA = " +data);
							  //System.out.println(" NUR st3.nextToken  aaaa " + a);
							  //System.out.println(" NUR st3.nextToken  bbbb " + b);
							  //System.out.println(" NUR st3.nextToken  cccc " + c);
							  //System.out.println(" NUR st3.nextToken  dddd " + d);
						      }
					      }
				      }
			      }
		      }
		  
	    case 'f':
		
		// Der Fall "Flag gesehen"
		
		StringTokenizer st4   = new StringTokenizer(data, " ");
		
		
		if (st4.countTokens() == 1)
		    {
			
			String a = st4.nextToken();
			
			try{
			    direction  = Double.valueOf(a).doubleValue();
			}
			
			catch(NumberFormatException st41)
			    {
				//System.out.println(" MESSAGE " + message);
				//System.out.println(" CODE " + code);
				//System.out.println(" DATA " + data);
				//System.out.println(" DATA = " +data);
				//System.out.println(" NUR st4.nextToken  aaaa " + a);
			    }
			catch(NoSuchElementException st41)
			    {
				//System.out.println(" MESSAGE " + message);
				//System.out.println(" CODE " + code);
				//System.out.println(" DATA " + data);
				//System.out.println(" DATA = " +data);		
				//System.out.println(" NUR st4.nextToken  aaaa " + a);
			    }
			
		    }
		else
		    {
			if (st4.countTokens() == 2)
			    
			    {
				String a = st4.nextToken();
				String b = st4.nextToken();
				
				try{
				    distance  = Double.valueOf(a).doubleValue();
				    direction = Double.valueOf(b).doubleValue();
				}
				catch(NumberFormatException st42)
				    {
					//System.out.println(" MESSAGE " + message);
					//System.out.println(" CODE " + code);
					//System.out.println(" DATA " + data);
					//System.out.println(" DATA = " +data);
					//System.out.println(" NUR st4.nextToken  aaaa " + a);
					//System.out.println(" NUR st4.nextToken  bbbb " + b);
				    }
				catch(NoSuchElementException st42)
				    {
					//System.out.println(" MESSAGE " + message);
					//System.out.println(" CODE " + code);
					//System.out.println(" DATA " + data);
					//System.out.println(" DATA = " +data);
					//System.out.println(" NUR st4.nextToken  aaaa " + a);
					//System.out.println(" NUR st4.nextToken  bbbb " + b);
				    }
			    }
			else
			    {
				if (st4.countTokens() == 3)
				    {
					
					String a = st4.nextToken();
					String b = st4.nextToken();
					String c = st4.nextToken();
					
					try
					    {
						distance  = Double.valueOf(a).doubleValue();
						direction = Double.valueOf(b).doubleValue();
						distChange = Double.valueOf(c).doubleValue();
					    }
					catch(NumberFormatException st43)
					    {
						//System.out.println(" MESSAGE " + message);
						//System.out.println(" CODE " + code);
						//System.out.println(" DATA " + data);
						//System.out.println(" DATA = " +data);
						//System.out.println(" NUR st4.nextToken  aaaa " + a);
						//System.out.println(" NUR st4.nextToken  bbbb " + b);
						//System.out.println(" NUR st4.nextToken  cccc " + c);
					}
					catch(NoSuchElementException st43)
					    {
						//System.out.println(" MESSAGE " + message);
						//System.out.println(" CODE " + code);
						//System.out.println(" DATA " + data);
						//System.out.println(" DATA = " +data);
						//System.out.println(" NUR st4.nextToken  aaaa " + a);
						//System.out.println(" NUR st4.nextToken  bbbb " + b);
						//System.out.println(" NUR st4.nextToken  cccc " + c);
					}
				    }
				else
				    {
					if (st4.countTokens() >= 4)
					    {

						String a = st4.nextToken();
						String b = st4.nextToken();
						String c = st4.nextToken();
						String d = st4.nextToken();
						
						  try{
						      distance  = Double.valueOf(a).doubleValue();
						      direction = Double.valueOf(b).doubleValue();
						      distChange = Double.valueOf(c).doubleValue();
						      dirChange = Double.valueOf(d).doubleValue();
						  }
						  catch(NumberFormatException st44)
						      {
							  //System.out.println(" MESSAGE " + message);
							  //System.out.println(" CODE " + code);
							  //System.out.println(" DATA " + data);
							  //System.out.println(" DATA = " +data);
							  //System.out.println(" NUR st4.nextToken  aaaa " + a);
							  //System.out.println(" NUR st4.nextToken  bbbb " + b);
							  //System.out.println(" NUR st4.nextToken  cccc " + c);
							  //System.out.println(" NUR st4.nextToken  dddd " + d);
						      }
						  catch(NoSuchElementException nst44)
						      {
							  //System.out.println(" MESSAGE " + message);
							  //System.out.println(" CODE " + code);
							  //System.out.println(" DATA " + data);
							  //System.out.println(" DATA = " +data);
							  //System.out.println(" NUR st4.nextToken  aaaa " + a);
							  //System.out.println(" NUR st4.nextToken  bbbb " + b);
							  //System.out.println(" NUR st4.nextToken  cccc " + c);
							  //System.out.println(" NUR st4.nextToken  dddd " + d);
						      }
						  }
					    }
				    }
					}
		
              case 'l': 
		  
		  // Der Fall "Aussenlinie gesehen"

		  StringTokenizer st5   = new StringTokenizer(data, " ");
		  
		  
		  if (st5.countTokens() == 1)
		      {
			  String a = st5.nextToken();
			  
			  try{
			      direction  = Double.valueOf(a).doubleValue();}
			  catch(NumberFormatException st51)
			      { 
				  //System.out.println(" MESSAGE " + message);
				  //System.out.println(" CODE " + code);
				  //System.out.println(" DATA " + data); 
				  //System.out.println(" DATA = " +data);
				  //System.out.println(" NUR st5.nextToken  aaaa " + a);
			      }
			  catch(NoSuchElementException st51)
			      {  
				  //System.out.println(" MESSAGE " + message);
				  //System.out.println(" CODE " + code);
				  //System.out.println(" DATA " + data);
				  //System.out.println(" DATA = " +data);
				  //System.out.println(" NUR st5.nextToken  aaaa " + a);
			      }
		      }
		  else
		      {
			  if (st5.countTokens() == 2)
			      {
				  String a = st5.nextToken();
				  String b = st5.nextToken();
				  
				  try{
				      distance  = Double.valueOf(a).doubleValue();
				      direction = Double.valueOf(b).doubleValue();}
				  catch(NumberFormatException st52){
				      //System.out.println(" MESSAGE " + message);
				      //System.out.println(" CODE " + code);
				      //System.out.println(" DATA " + data);
				      //System.out.println(" DATA = " +data);
				      //System.out.println(" NUR st5.nextToken  aaaa " + a);
				      //System.out.println(" NUR st5.nextToken  bbbb " + b);
				  }
				  catch(NoSuchElementException st52){
				      //System.out.println(" MESSAGE " + message);
				      //System.out.println(" CODE " + code);
				      //System.out.println(" DATA " + data);
				      //System.out.println(" DATA = " +data);
				      //System.out.println(" NUR st5.nextToken  aaaa " + a);
				      //System.out.println(" NUR st5.nextToken  bbbb " + b);
				  }
			      }
			  else
			      {
				  if (st5.countTokens() == 3)
				      {
					  String a = st5.nextToken();
					  String b = st5.nextToken();
					  String c = st5.nextToken();
					
					  try{
					      distance  = Double.valueOf(a).doubleValue();
					      direction = Double.valueOf(b).doubleValue();
					      distChange = Double.valueOf(c).doubleValue();
					  }
					  catch(NumberFormatException st53){
					      //System.out.println(" MESSAGE " + message);
					      //System.out.println(" CODE " + code);
					      //System.out.println(" DATA " + data);
					      //System.out.println(" DATA = " +data);
					      //System.out.println(" NUR st5.nextToken  aaaa " + a);
					      //System.out.println(" NUR st5.nextToken  bbbb " + b);
					      //System.out.println(" NUR st5.nextToken  cccc " + c);
					  }
					  catch(NoSuchElementException st53){
					      //System.out.println(" MESSAGE " + message);
					      //System.out.println(" CODE " + code);
					      //System.out.println(" DATA " + data);
					      //System.out.println(" DATA = " +data);
					      //System.out.println(" NUR st5.nextToken  aaaa " + a);
					      //System.out.println(" NUR st5.nextToken  bbbb " + b);
					      //System.out.println(" NUR st5.nextToken  cccc " + c);
}
				      }
				  else
				      {
					  if (st5.countTokens() >= 4)
					      {

						  String a = st5.nextToken();
						  String b = st5.nextToken();
						  String c = st5.nextToken();
						  String d = st5.nextToken();
						
						  try{
						      distance  = Double.valueOf(a).doubleValue();
						      direction = Double.valueOf(b).doubleValue();
						      distChange = Double.valueOf(c).doubleValue();
						      dirChange = Double.valueOf(d).doubleValue();
						  }
						  catch(NumberFormatException st54){
						      //System.out.println(" MESSAGE " + message);
						      //System.out.println(" CODE " + code);
						      //System.out.println(" DATA " + data);
						      //System.out.println(" DATA = " +data);
						      //System.out.println(" NUR st5.nextToken  aaaa " + a);
						      //System.out.println(" NUR st5.nextToken  bbbb " + b);
						      //System.out.println(" NUR st5.nextToken  cccc " + c);
						      //System.out.println(" NUR st5.nextToken  dddd " + d);
						  }

						  catch(NoSuchElementException st54){
						      //System.out.println(" MESSAGE " + message);
						      //System.out.println(" CODE " + code);
						      //System.out.println(" DATA " + data);
						      //System.out.println(" DATA = " +data);
						      //System.out.println(" NUR st5.nextToken  aaaa " + a);
						      //System.out.println(" NUR st5.nextToken  bbbb " + b);
						      //System.out.println(" NUR st5.nextToken  cccc " + c);
						      //System.out.println(" NUR st5.nextToken  dddd " + d);
						  }
					      }
				      }
			      }
		      }

		  // Schreibe in die VisualInfo Datei!
		  visualInfo = new VisualInfo(time, code, distance, direction, distChange, dirChange);
		  this.add(visualInfo);
		  break;
 


            }
          }
        }
    }
    
    
}
























